/***********************************************
*  t\탉Cu
*  I2CC^[tF[X
*    lcd_init()    ----- 
*    lcd_cmd(cmd)  ----- R}ho
*    lcd_data(data) ----- P\o
*    lcd_str(ptr)  ----- \o
*    lcd_clear()   ----- S
**********************************************/
#include <htc.h>
#include "lcd_i2c_lib.h"
#include "i2c_lib1.h"

/*********************************
* t1\f[^o
*********************************/
void lcd_data(unsigned char data)
{
	I2CStart();					// X^[g
	I2COut(0x7C);					// AhX
	I2COut(0x40);					// \f[^w
	I2COut(data);					// \f[^o
	I2CStop();					// Xgbv
	__delay_us(30);				// x
}

/*******************************
* tւPR}ho 
*******************************/
void lcd_cmd(unsigned char cmd)
{
	I2CStart();					// X^[g
	I2COut(0x7C);					// AhX
	I2COut(0x00);					// R}hw
	I2COut(cmd);					// R}ho
	I2CStop();					// Xgbv
	/* ClearHome */
	if((cmd == 0x01)||(cmd == 0x02))
		__delay_ms(2);			// 2msec҂
	else
		__delay_us(30);			// 30sec҂	
}
/*******************************
*  ֐ 
*******************************/
void lcd_init(void)
{
	delay_100ms(1);
	lcd_cmd(0x38);				// 8bit 2line Normal mode
	lcd_cmd(0x39);				// 8bit 2line Extend mode	
	lcd_cmd(0x14);				// OSC 183Hz BIAS 1/5
	/* RgXgݒ */
	lcd_cmd(0x70 + (CONTRAST & 0x0F));
	lcd_cmd(0x5C + (CONTRAST >> 4));
//	lcd_cmd(0x6A);				// Follower for 5.0V
	lcd_cmd(0x6B);				// Ffollwer for 3.3V
	delay_100ms(3);
	lcd_cmd(0x38);				// Set Normal mode 
	lcd_cmd(0x0C);				// Display On 
	lcd_cmd(0x01);				// Clear Display 
}
/******************************
* S֐
******************************/
void lcd_clear(void)
{
	lcd_cmd(0x01);				//R}ho
}
/*****************************
* \֐
*****************************/
void lcd_str(const unsigned char* ptr)
{
	while(*ptr != 0)				//o 
		lcd_data(*ptr++);			//\
}
/*****************************
*  ACR\֐
*****************************/
void lcd_icon(unsigned char num, unsigned char onoff)
{
	lcd_cmd(0x39);				// Extend mode
	lcd_cmd(0x40 | ICON[num][0]);	// ACRAhXw
	if(onoff)
		lcd_data(ICON[num][1]);	// ACRIf[^
	else
		lcd_data(0x00);			// ACRItf[^
	lcd_cmd(0x38);				// Normal Mode
}

/******************************
*  100msecx֐
******************************/
void delay_100ms(unsigned int time)
{
	time *= 4;					// 4{
	while(time){
		__delay_ms(25);			// 25msec
		time--;					// 100msec x time
	}
}
